// CUSTOMERIMPL.H : Declaration of the TCustomerImpl

#ifndef CustomerImplH
#define CustomerImplH

#include "ModalWinBcb_TLB.H"


/////////////////////////////////////////////////////////////////////////////
// TCustomerImpl     Implements ICustomer, default interface of Customer
// ThreadingModel : Apartment
// Dual Interface : TRUE
// Event Support  : FALSE
// Default ProgID : ModalWinBcb.Customer
// Description    : 
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TCustomerImpl : 
  public CComObjectRootEx<CComSingleThreadModel>,
  public CComCoClass<TCustomerImpl, &CLSID_Customer>,
  public IDispatchImpl<ICustomer, &IID_ICustomer, &LIBID_ModalWinBcb>
{
public:
  TCustomerImpl()
  {
    ShowMessage("Impl Constructor");
  }

  ~TCustomerImpl()
  {
    ShowMessage("Impl Destructor");
  }

  // Data used when registering Object 
  //
  DECLARE_THREADING_MODEL(otApartment);
  DECLARE_PROGID("ModalWinBcb.Customer");
  DECLARE_DESCRIPTION("");

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<TCustomerImpl> 
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }


BEGIN_COM_MAP(TCustomerImpl)
  COM_INTERFACE_ENTRY(ICustomer)
  COM_INTERFACE_ENTRY2(IDispatch, ICustomer)
END_COM_MAP()

// ICustomer
public:
 
  STDMETHOD(ShowByZip(long handle, BSTR zip));
};

#endif //CustomerImplH
